/*-
 * ~~~~~~licensing~~~~~~
 * bridge-profile-manager
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.bridge.profile.manager.sender;

import com.google.gson.Gson;
import org.apache.camel.CamelContext;
import org.apache.camel.Exchange;
import org.apache.camel.ProducerTemplate;
import org.apache.camel.builder.ExchangeBuilder;

import java.io.IOException;

public class BridgeProfileSenderImpl implements BridgeProfileSender {

    private static final String HEADER_BRIDGE_NAME = "NTX_Bridge";
    private static final String HEADER_COMMAND = "NTX_CommandBridgeProfileManager";
    private static final String HEADER_DESTINATION_SYSTEM = "NTX_DestinationQueueAfterBridge";

    private static final Gson gson = new Gson();
    
    private CamelContext context;

    @Override
    public String sendOnOtherEsb(BridgeProfileType bridgeProfileType, String esbName, String command) {
        Exchange exchange = ExchangeBuilder.anExchange(context)
                .withHeader(HEADER_DESTINATION_SYSTEM, "profile-controller-route")
                .withHeader(HEADER_BRIDGE_NAME, esbName)
                .withHeader(HEADER_COMMAND, command)
                .withBody(gson.toJson(bridgeProfileType))
                .build();

        try (ProducerTemplate template = exchange.getContext().createProducerTemplate()) {
            template.send("direct-vm:send-message", exchange);
        } catch (IOException e) {
            throw new RuntimeException("Something happened when was sending into direct-vm:send-message", e);
        }

        return exchange.getOut() != null && exchange.getOut().getBody() != null ?
                exchange.getOut().getBody().toString() : null;
    }

	public CamelContext getContext() {
		return context;
	}

	public void setContext(CamelContext context) {
		this.context = context;
	}
    
    
}
